#ifndef _FIREFLY_SHA1_H_
#define _FIREFLY_SHA1_H_

#include "crypto/crypto_types.h"

#include "stl/stdint.hpp"
#include "stl/stddef.hpp"

struct sha1_ctx {
    stl::UInt32T _hash[5];
    stl::UInt8T _data[64];
    size64_t _data_len;
    size64_t _bit_len;
};

struct sha1_hmac_ctx {
    struct sha1_ctx _sha_ctx;
    stl::UInt8T _key[SIZEOF(struct sha1_ctx, _hash)];
    size64_t _key_length;
    stl::UInt8T _digest[SIZEOF(struct sha1_ctx, _hash)];
};

void sha1_init(struct sha1_ctx* const ctx);
void sha1_update(struct sha1_ctx* const ctx, const stl::UInt8T* input, size64_t length);
const stl::UInt8T* sha1_finish(struct sha1_ctx* const ctx);

void sha1_hmac_init(struct sha1_hmac_ctx* const ctx, const stl::UInt8T* key
    , const size64_t key_length);
const stl::UInt8T* sha1_hmac_finish(struct sha1_hmac_ctx* const ctx
    , const char* message, const size64_t message_length);

#endif
