#ifndef __DRIVERS_GPIO_HPP__
#define __DRIVERS_GPIO_HPP__

#include "stl/stl_config.hpp"

#if (defined STL_ENABLE_GPIO && (STL_ENABLE_GPIO == 1))

#include "stl/stdint.hpp"

namespace stl::driver::board {
using GPIOT = stl::UInt16T;
using GPIOFuncT = stl::UInt32T;

enum class GPIORetvE
{
  Ok,
  IndexOutOfRange,
  Error,
  InvalidValue
};

enum class GPIOEdgeE
{
  Setup,
  Rising,
  Falling,
  Both
};

enum class GPIOLvlE
{
  Low,
  High
};

enum class GPIODirE
{
  Input,
  Output
};

bool
GPIO_init();

GPIORetvE
GPIO_setLvl(const GPIOT gpio, const GPIOLvlE lvl);
GPIORetvE
GPIO_getLvl(const GPIOT gpio, GPIOLvlE& lvl);
GPIORetvE
GPIO_setDir(const GPIOT gpio, const GPIODirE dir);
GPIORetvE
GPIO_getDir(const GPIOT gpio, GPIODirE& dir);
GPIORetvE
GPIO_setFunc(const GPIOT gpio, const GPIOFuncT func);
GPIORetvE
GPIO_getFunc(const GPIOT gpio, GPIOFuncT& func);
GPIORetvE
GPIO_watchISR(const GPIOT gpio, const GPIOEdgeE mode, void(*func)());
GPIORetvE
GPIO_unwatchISR(const GPIOT gpio);
}

#endif // (defined STL_ENABLE_GPIO && (STL_ENABLE_GPIO == 1))

#endif
