#ifndef __STL_JSON_HPP__
#define __STL_JSON_HPP__

#include "nlohmann/json.hpp"

#include "stl/compiler.hpp"
#include "stl/filesystem.hpp"
#include "stl/stdint.hpp"

namespace stl::parser {
enum class JSONError
{
  Ok,
  ParserError,
  DoesNotExist,
  NoAccess,
  DumpError,
  ReadError,
  WriteError
};

using JSON = nlohmann::json;

JSONError
JSON_load(const filesystem::Path& path, JSON& json);
JSONError
JSON_save(const filesystem::Path& path, const JSON& json);
}

#endif // __STL_JSON_HPP__
