#ifndef _ASSERT_HPP_
#define _ASSERT_HPP_

#include "stl/stl_config.hpp"

#if defined(STL_ENABLE_DEBUG) && (STL_ENABLE_DEBUG == 1) &&                    \
  defined STL_ENABLE_ASSERT && (STL_ENABLE_ASSERT == 1)

#include "stl/compiler.hpp"
#include "stl/stddef.hpp"

#ifdef _MSC_VER

#include <assert.h>

#define Assert(expr) assert(expr)

#else

namespace stl {
bool
_Assert(const bool expr, const char* file, const SizeT line);
}

#define Assert(expr) stl::_Assert(!!(expr), __FILENAME__, __LINE__)

#endif

#else

#define Assert(expr)

#endif // STL_ENABLE_DEBUG
#endif
