#ifndef _ENDIAN_HPP_
#define _ENDIAN_HPP_

#include "stl/stl_config.hpp"

#include "stl/stdint.hpp"

namespace stl {
    enum class EndianE {
        EndianE_Little
        , EndianE_Big
        // TODO: More endian types
        , _Count
    };

    class Endian {
    public:
        static EndianE host() {
            return m_host;
        }

        template<typename T>
        static T swap(T value);

        template<typename T>
        static T hostSync(const EndianE endian, const T value) {
            if (endian == host()) {
                return value;
            }

            return swap(value);
        }

    private:
        static constexpr UInt32T m_test = 0xCC00FFEEU;
        static const EndianE m_host;
    };

    template<>
    inline UInt8T Endian::swap(UInt8T value) {
        return value;
    }
}

#endif
