#ifndef _STL_ERROR_HPP_
#define _STL_ERROR_HPP_

#include "stl/stl_config.hpp"

#define STL_ERROR_LIST \
/* 1  */ XENTRY(Ok = 1) \
/* 2  */ XENTRY(FileNotOpen) \
/* 3  */ XENTRY(WriteError) \
/* 4  */ XENTRY(ReadError) \
/* 5  */ XENTRY(FormatError) \
/* 6  */ XENTRY(PermissionError) \
/* 7  */ XENTRY(InvalidArgument) \
/* 8  */ XENTRY(ArgumentOutOfRange) \
/* 9  */ XENTRY(UnknownError) \
/* 10 */ XENTRY(BusError) \
/* 11 */ XENTRY(ValueOutOfRange) \
/* 12 */ XENTRY(Assert) \
/* 13 */ XENTRY(MaximumItemCountReached) \
/* 14 */ XENTRY(ItemAlreadyExists) \
/* 15 */ XENTRY(ItemDoesNotExist) \
/* 16 */ XENTRY(NoDeviceID) \
/* 17 */ XENTRY(UnknownDeviceID) \
/* 18 */ XENTRY(DeviceBusy) \
/* 19 */ XENTRY(UnsupportedDevice) \
/* 20 */ XENTRY(InvalidConfig) \
/* 21 */ XENTRY(UnsupportedDeviceProtocolVersion) \
/* 22 */ XENTRY(DeviceInformationGetFailed) \
/* 23 */ XENTRY(DeviceInformationSetFailed) \
/* 24 */ XENTRY(OperationInProgress) \
/* 25 */ XENTRY(OperationNotInProgress) \
/* 26 */ XENTRY(OperationTimedOut) \
/* 27 */ XENTRY(InvalidChecksum) \
/* 28 */ XENTRY(ConnectionError) \
/* 29 */ XENTRY(ExternalDeviceError) \
/* 30 */ XENTRY(ValueDoesNotMatch) \
/* 31 */ XENTRY(OperationCanceled) \
/* 32 */ XENTRY(DeviceNotReadyForOperation) \
/* 33 */ XENTRY(Overflow) \
/* 34 */ XENTRY(DeviceNotAvailable) \
/* 35 */ XENTRY(NotFound) \
/* 36 */ XENTRY(InvalidRequest)

namespace stl {
enum class ErrorE
{
#define XENTRY(value) value,
  STL_ERROR_LIST
#undef XENTRY
  _Count
};
}

#endif