#ifndef _FILESYSTEM_HPP_
#define _FILESYSTEM_HPP_

#include "stl/stl_config.hpp"

#ifdef STL_ENABLE_FILESYSTEM
#if __has_include(<filesystem>)

#include "stl/string.hpp"

// Include
#include <filesystem>

// Namespace define
namespace stl::filesystem {
using namespace std::filesystem;
using Path = String;
}

#elif __has_include(<experimental/filesystem>)

// Define used to prevent compilation error due to deprecated include warning
#define _SILENCE_EXPERIMENTAL_FILESYSTEM_DEPRECATION_WARNING

// Include
#include <experimental/filesystem>

// Namespace define
namespace stl {
using namespace std::experimental::filesystem;
}

#else
#error "<filesystem> is not supported by the platform"
#endif
#endif

#endif
