#ifndef __STL_ISTREAM_HPP__
#define __STL_ISTREAM_HPP__

#include "stl/string.hpp"

#include "stl/stddef.hpp"
#include "stl/stl_config.hpp"
#include "stl/stream_base.hpp"

namespace stl::stream {
class IStreamBase : virtual public StreamBase
{
public:
  IStreamBase() = default;

  virtual SizeT read(UInt8T* data, SizeT maxSize) = 0;

private:
};

class IStream : public stream::IStreamBase
{
public:
  template<typename T>
  IStream& operator>>(const T* const value);

  template<typename T>
  IStream& operator>>(T* const value);

  template<typename T>
  IStream& operator>>(const T& value);

  virtual void flush() override {}

private:
  virtual SizeT read(UInt8T* data, SizeT maxSize) override { return 0U; }

  virtual bool seek(const SizeT offset, const SeekModeE seekMode) override
  {
    return false;
  }

  virtual SizeT position() const override { return 0U; }

  virtual SizeT size() const override { return 0U; }
};

}

#endif // __STL_STREAM_HPP__