#ifndef __STL_FSTREAM_IMPL_LINUX_HPP__
#define __STL_FSTREAM_IMPL_LINUX_HPP__

#include "stl/compile_info.hpp"
#include "stl/stl_config.hpp"

#include "stl/fstream.hpp"

#if 1 // defined(CI_SUPPORT_STD) && (CI_SUPPORT_STD == 1) && (CI_OS_LINUX == 1)

namespace stl::stream {
class FStream::FStreamImpl : FStreamBase
{
public:
  FStreamImpl();

  FStreamImpl(const FStreamImpl&) = delete;
  FStreamImpl& operator=(const FStreamImpl&) = delete;

  FStreamImpl(FStreamImpl&& other);

  FStreamImpl& operator=(FStreamImpl&& other);

  FStreamImpl(filesystem::Path path, const FileFlagsT flags);

  virtual ~FStreamImpl();

  virtual void flush() override;

  virtual bool open(filesystem::Path path, const FileFlagsT flags) override;

  virtual bool isOpen() const override;

  virtual SizeT read(UInt8T* data, SizeT maxSize);

  virtual SizeT write(const UInt8T* const data, SizeT size) override;

  virtual bool seek(const SizeT offset, const SeekModeE seekMode) override;

  virtual SizeT position() const override;

  virtual void close() override;

  virtual SizeT size() const override;

  operator bool() const;

  int fd() const;

private:
  bool openInternal();

  mutable int m_fd;
};
}
#endif // defined(CI_SUPPORT_STD) && (CI_SUPPORT_STD == 1) && (CI_OS_LINUX == 1)

#endif // __STL_FSTREAM_IMPL_LINUX_HPP__
