#ifndef _STL_CONFIG_HPP_
#define _STL_CONFIG_HPP_

// *** Options ***************************************** //

#if !defined(LIBSTL)
#define LIBSTL 0
#endif

#define STL_ENABLE_DEBUG 1

#define STL_ENABLE_INT64 1

// TODO: Determine bitness
// #define STL_SET_SIZE_T_8
// #define STL_SET_SIZE_T_16
// #define STL_SET_SIZE_T_32
#define STL_SET_SIZE_T_64

#define STL_ENABLE_FLOAT 1
// #define STL_ENABLE_DOUBLE 1
// #define STL_ENABLE_LONG_DOUBLE 1

#ifndef STL_ENABLE_IOSTREAM
#define STL_ENABLE_IOSTREAM 1
#endif // STL_ENABLE_IOSTREAM

#ifndef STL_ENABLE_SSL
#define STL_ENABLE_SSL 1
#endif

#if defined(STL_ENABLE_SSL) && (STL_ENABLE_SSL == 1)
#ifndef STL_ENABLE_SSL_SERVER
#define STL_ENABLE_SSL_SERVER LIBSTL
#endif

#ifndef STL_ENABLE_SSL_CLIENT
#define STL_ENABLE_SSL_CLIENT LIBSTL
#endif
#endif // defined(STL_ENABLE_SSL) && (STL_ENABLE_SSL == 1)

// Assert
#ifndef STL_ENABLE_ASSERT
#define STL_ENABLE_ASSERT 1
#endif // STL_ENABLE_ASSERT

// Network
#ifndef STL_ENABLE_NETWORKING
#define STL_ENABLE_NETWORKING LIBSTL
#endif // STL_ENABLE_NETWORKING

// Logging
#ifndef STL_ENABLE_LOGGING
#define STL_ENABLE_LOGGING LIBSTL
#endif // STL_ENABLE_NETWORKING

// GPIO
#ifndef STL_ENABLE_GPIO
#define STL_ENABLE_GPIO LIBSTL
#endif

#if defined(STL_ENABLE_GPIO) && (STL_ENABLE_GPIO == 1)
#ifndef STL_ENABLE_UART
#define STL_ENABLE_UART 0
#endif // STL_ENABLE_UART
#else
#ifdef STL_ENABLE_UART
#undef STL_ENABLE_UART
#define STL_ENABLE_UART 0
#endif // STL_ENABLE_UART
#endif // STL_ENABLE_GPIO

// Threading
#ifndef STL_ENABLE_THREADING
#define STL_ENABLE_THREADING 1
#endif

// Filesystem
#ifndef STL_ENABLE_FILESYSTEM
#define STL_ENABLE_FILESYSTEM 0
#endif

// File stream
#ifndef STL_ENABLE_FILESTREAM
#define STL_ENABLE_FILESTREAM 0
#endif

// Exceptions
#define STL_ENABLE_EXCEPTION
#if defined STL_ENABLE_EXCEPTION
#define THROW() throw
#define THROW_EX(ex) throw(ex)
#elif defined STL_ENABLE_ASSERT
#define THROW(ex) Assert(false)
#define THROW_EX(ex) Assert(false)
#else
#define THROW(ex)
#endif

// *** Do not change this section ********************** //

#include "stl/stl_config_private.hpp"

#ifdef _MSC_VER
#pragma warning(disable : 4506)
#endif

#endif
