#ifndef __STL_STREAM_BASE_HPP__
#define __STL_STREAM_BASE_HPP__

#include "stl/string.hpp"

#include "stl/stddef.hpp"
#include "stl/stl_config.hpp"

namespace stl::stream {
class StreamBase
{
public:
  enum class SeekModeE
  {
    Beg,
    Set,
    End
  };

  StreamBase() = default;
  virtual ~StreamBase() = default;

  virtual void flush() = 0;

  virtual bool seek(const SizeT offset, const SeekModeE seekMode) = 0;

  virtual SizeT position() const = 0;

  virtual SizeT size() const = 0;

private:
};
}

#endif // __STL_STREAM_HPP__