#!/bin/bash

ROOT_DIR="$(dirname "$0")"

# TODO: Optimize/fix this script

if ! command -v git &> /dev/null
then
    echo "[info] Installing git.."
    
    sudo apt install git > /dev/null
    
    ERROR_CODE=$?
    
    if [ $ERROR_CODE -ne 0 ]; then
        echo "[error] Could not install git! [$ERROR_CODE]"
        exit 66
    fi
fi

if ! command -v autoconf &> /dev/null
then
    echo "[info] Installing autoconf.."
    
    sudo apt install autoconf > /dev/null
    
    ERROR_CODE=$?
    
    if [ $ERROR_CODE -ne 0 ]; then
        echo "[error] Could not install autoconf! [$ERROR_CODE]"
        exit 66
    fi
fi

if ! command -v automake &> /dev/null
then
    echo "[info] Installing automake.."
    
    sudo apt install automake > /dev/null
    
    ERROR_CODE=$?
    
    if [ $ERROR_CODE -ne 0 ]; then
        echo "[error] Could not install automake! [$ERROR_CODE]"
        exit 66
    fi
fi

if ! command -v libtool &> /dev/null
then
    echo "[info] Installing libtool.."
    
    sudo apt install libtool > /dev/null
    
    ERROR_CODE=$?
    
    if [ $ERROR_CODE -ne 0 ]; then
        echo "[error] Could not install libtool! [$ERROR_CODE]"
        exit 66
    fi
fi

cd ${ROOT_DIR}/thirdparty/openssl

git submodule update --init

./Configure --prefix=/usr/local/ --openssldir=/usr/local/ '-Wl,--enable-new-dtags,-rpath,$(LIBRPATH)'

make

make test

make install

cd ${ROOT_DIR}/thirdparty/libmodbus
./configure --prefix=/usr/local/ && make install

cd ${ROOT_DIR}

exit 0
