#include "stl/stl_config.hpp"
#include "stl/compile_info.hpp"
#include "stl/compiler.hpp"

#if (defined STL_ENABLE_LOGGING && (STL_ENABLE_LOGGING == 1)) \
    && (defined CI_PLATFORM_MKRWIFI1010 && (CI_PLATFORM_MKRWIFI1010 == 1))

#include "log/logging.hpp"

#include "stl/assert.hpp"
#include "stl/iostream.hpp"

#include "Arduino.h"

// TODO: Make common basic stream for logger and iostream

namespace logging {
  template<>
  Logger& Logger::operator << (const arduino::__FlashStringHelper* flashString) {
    Assert(flashString);

    stl::cout << flashString;

    return *this;
  }

  template<>
  Logger& Logger::operator << (const arduino::StringSumHelper& stringSumHelper) {
    stl::cout << stringSumHelper;

    return *this;
  }

  Logger& Logger::operator << (const ClrE color) {
    UNUSED_PARAM(color);

    return *this;
  }

  template<>
  Logger& Logger::operator << (const String& string) {
    stl::cout.write(string.c_str(), string.length());

    return *this;
  }
}

logging::Logger& operator << (logging::Logger& stream, const arduino::__FlashStringHelper* const flashString) {
  Assert(flashString);

  stl::cout << flashString;

  return stream;
}

logging::Logger& operator << (logging::Logger& stream, const arduino::StringSumHelper& stringSumHelper) {
  stl::cout << stringSumHelper;

  return stream;
}

#endif // defined CI_PLATFORM_MKRWIFI1010 && (CI_PLATFORM_MKRWIFI1010 == 1)
