#include "stl/compile_info.hpp"
#include "stl/stl_config.hpp"

#if (defined STL_ENABLE_LOGGING && (STL_ENABLE_LOGGING == 1)) &&               \
  (defined CI_OS_WINDOWS && (CI_OS_WINDOWS == 1))

#include "log/logging.hpp"

#include "stl/assert.hpp"
#include "stl/iostream.hpp"

#include <Windows.h>

#include <string>

// TODO: Make common basic stream for logger and iostream

static WORD
colorToCode(const stl::ClrE color)
{
  switch (color) {
    case stl::ClrE::Black:
      return 0;
    case stl::ClrE::Gray:
      return 8U;
    case stl::ClrE::Blue:
      return 1U;
    case stl::ClrE::LightBlue:
      return 9U;
    case stl::ClrE::Green:
      return 2U;
    case stl::ClrE::LightGreen:
      return 10U;
    case stl::ClrE::Aqua:
      return 3U;
    case stl::ClrE::LightAqua:
      return 11U;
    case stl::ClrE::Red:
      return 4U;
    case stl::ClrE::LightRed:
      return 12U;
    case stl::ClrE::Purple:
      return 5U;
    case stl::ClrE::LightPurple:
      return 13U;
    case stl::ClrE::Yellow:
      return 6U;
    case stl::ClrE::LightYellow:
      return 14U;
    case stl::ClrE::White:
      return 7U;
    case stl::ClrE::BrightWhite:
      return 15U;
    case stl::ClrE::_Count:
      break;
    default:
      break;
  }

  return 0;
}

template<>
stl::stream::OStreamBase&
stl::stream::OStreamBase::operator<<(const stl::ClrE& color)
{
  if(OutputE::Terminal == m_output) {
    static HANDLE hConsole = GetStdHandle(STD_OUTPUT_HANDLE);

    SetConsoleTextAttribute(hConsole, colorToCode(color));
  }
  return *this;
}

template<>
template<>
stl::stream::OStreamBase&
stl::stream::OStreamBase::operator<<(const std::string& string)
{
  stl::cout.write(string.c_str(), string.length());

  return *this;
}

stl::stream::OStreamBase&
operator<<(stl::stream::OStreamBase& stream, const stl::ClrE& color)
{
  static HANDLE hConsole = GetStdHandle(STD_OUTPUT_HANDLE);

  SetConsoleTextAttribute(hConsole, colorToCode(color));

  return stream;
}

stl::stream::OStreamBase&
operator<<(stl::stream::OStreamBase& stream, const std::string& string)
{
  stl::cout.write(string.c_str(), string.length());

  return stream;
}

#endif // #if defined CI_OS_WINDOWS && (CI_OS_WINDOWS == 1)
