#include "stl/stl_config.hpp"
#include "stl/compile_info.hpp"
#include "stl/compiler.hpp"

#include "stl/stddef.hpp"
#include "stl/iostream.hpp"
#include "stl/thread.hpp"
#include "stl/string_conv.hpp"

#if (defined CI_PLATFORM_MKRWIFI1010 && (CI_PLATFORM_MKRWIFI1010 == 1)) \
    && (defined STL_ENABLE_ASSERT && (STL_ENABLE_ASSERT == 1))

namespace stl {
    bool _Assert(const bool expr, const char* file, const SizeT line) {
        if(!expr) {
            // stl::cout << "[assert] " << file << " #" << line << stl::endl;

            char lineStr[16] = {};

            string::toString<SizeT>(line, 10U, lineStr, sizeof(lineStr));

            stl::cout.writeAssert("[assert] ");
            stl::cout.writeAssert(file);
            stl::cout.writeAssert(" #");
            stl::cout.writeAssert(lineStr);
            stl::cout.writeAssert("\r\n");

            while(true) { stl::thread::sleepFor(500); };

            return false;
        }

        return true;
    }
}

#endif
