#include "stl/compile_info.hpp"
#include "stl/stl_config.hpp"

#if (defined STL_ENABLE_LOGGING && (STL_ENABLE_LOGGING == 1))

#include "log/logging.hpp"

#include "stl/assert.hpp"
#include "stl/error.hpp"
#include "stl/iostream.hpp"
#include "stl/math.hpp"
#include "stl/string_utils.hpp"

static const char*
errorToString(const stl::ErrorE error)
{
  Assert(error < stl::ErrorE::_Count);

  static const char* const strLUT[] = {
#define XENTRY(value) #value,
    STL_ERROR_LIST
#undef XENTRY
  };

  if (static_cast<stl::SizeT>(error) >= (sizeof(strLUT) / sizeof(strLUT[0]))) {
    return "";
  }

  return strLUT[static_cast<stl::SizeT>(error)];
}

template<>
stl::stream::OStreamBase&
stl::stream::OStreamBase::operator<<(const stl::ErrorE& error)
{
  *this << errorToString(error);

  return *this;
}

#endif // (defined STL_ENABLE_LOGGING && (STL_ENABLE_LOGGING == 1))
