#include "stl/compile_info.hpp"
#include "stl/stl_config.hpp"

#if defined CI_PLATFORM_MKRWIFI1010 && (CI_PLATFORM_MKRWIFI1010 == 1)

#include "stl/limits.hpp"
#include "stl/math.hpp"
#include "stl/random.hpp"
#include "stl/stdint.hpp"
#include "stl/time.hpp"

#include "Arduino.h"

namespace stl::random
{
void seed(const int seed) { ::randomSeed(seed); }

template <>
char random(const char min, const char max)
{
    return ::random(min, stl::math::min(stl::Limits<char>::max(),
                                        static_cast<char>(max + 1U)));
}

template <>
unsigned char random(const unsigned char min, const unsigned char max)
{
    return ::random(min, stl::math::min(stl::Limits<unsigned char>::max(),
                                        static_cast<unsigned char>(max + 1U)));
}

template <>
short random(const short min, const short max)
{
    return ::random(min, stl::math::min(stl::Limits<short>::max(),
                                        static_cast<short>(max + 1U)));
}

template <>
unsigned short random(const unsigned short min, const unsigned short max)
{
    return ::random(min, stl::math::min(stl::Limits<unsigned short>::max(),
                                        static_cast<unsigned short>(max + 1U)));
}

template <>
int random(const int min, const int max)
{
#if defined STL_ENABLE_INT64 && (STL_ENABLE_INT64 == 1)
    return ::random(min, stl::math::min(stl::Limits<int>::max(),
                                        static_cast<int>(max + 1U)));
#else
    return ::random(min, stl::math::min(stl::Limits<int>::max(), max));
#endif
}

template <>
unsigned int random(const unsigned int min, const unsigned int max)
{
#if defined STL_ENABLE_INT64 && (STL_ENABLE_INT64 == 1)
    return ::random(min, stl::math::min(stl::Limits<unsigned int>::max(),
                                        static_cast<unsigned int>(max + 1U)));
#else
    return ::random(min, stl::math::min(stl::Limits<unsigned int>::max(), max));
#endif
}

template <>
long random(const long min, const long max)
{
#if defined STL_ENABLE_INT64 && (STL_ENABLE_INT64 == 1)
    return ::random(min, stl::math::min(stl::Limits<long>::max(),
                                        static_cast<long>(max + 1U)));
#else
    return ::random(min, stl::math::min(stl::Limits<long>::max(), max));
#endif
}

template <>
unsigned long random(const unsigned long min, const unsigned long max)
{
#if defined STL_ENABLE_INT64 && (STL_ENABLE_INT64 == 1)
    return ::random(min, stl::math::min(stl::Limits<unsigned long>::max(),
                                        static_cast<unsigned long>(max + 1U)));
#else
    return ::random(min,
                    stl::math::min(stl::Limits<unsigned long>::max(), max));
#endif
}

#if defined STL_ENABLE_INT64 && (STL_ENABLE_INT64 == 1)

template <>
long long random(const long long min, const long long max)
{
    return ::random(min, stl::math::min(stl::Limits<long long>::max(), max));
}

template <>
unsigned long long random(const unsigned long long min,
                          const unsigned long long max)
{
    return ::random(
        min, stl::math::min(stl::Limits<unsigned long long>::max(), max));
}

#endif
} // namespace stl::random

#endif // defined CI_PLATFORM_MKRWIFI1010 && (CI_PLATFORM_MKRWIFI1010 == 1)
